Index: /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/create_restart.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/create_restart.f90	(revision 5599)
+++ /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/create_restart.f90	(revision 5600)
@@ -7,27 +7,150 @@
 !
 ! DESCRIPTION:
+!> @file
 !> @brief 
 !> This program create restart file.
 !>
 !> @details
-!> Variables are read from restart file, or standard output.
-!> Then theses variables are interpolated on fine grid. 
-!> Finally table are split over new decomposition. 
-!>
-!> @author
-!> J.Paul
+!> @section sec1 method
+!> Variables could be extracted from fine grid file, interpolated from coarse
+!> grid file or restart file, or manually written.<br/> 
+!> Then they are split over new decomposition. 
+!> @note 
+!>    method could be different for each variable.
+!>
+!> @section sec2 how to
+!>    to create restart file:<br/>
+!> @code{.sh}
+!>    ./SIREN/bin/create_restart create_restart.nam
+!> @endcode
+!>    
+!>    create_restart.nam comprise 9 namelists:<br/>
+!>       - logger namelist (namlog)
+!>       - config namelist (namcfg)
+!>       - coarse grid namelist (namcrs)
+!>       - fine grid namelist (namfin)
+!>       - vertical grid namelist (namzgr)
+!>       - partial step namelist (namzps)
+!>       - variable namelist (namvar)
+!>       - nesting namelist (namnst)
+!>       - output namelist (namout)
+!>    
+!>    @note 
+!>       All namelists have to be in file create_restart.nam 
+!>       however variables of those namelists are all optional.
+!>
+!>    * _logger namelist (namlog)_:<br/>
+!>       - cn_logfile   : log filename
+!>       - cn_verbosity : verbosity ('trace','debug','info',
+!> 'warning','error','fatal')
+!>       - in_maxerror  : maximum number of error allowed
+!>
+!>    * _config namelist (namcfg)_:<br/>
+!>       - cn_varcfg : variable configuration file
+!> (see ./SIREN/cfg/variable.cfg)
+!>
+!>    * _coarse grid namelist (namcrs):<br/>
+!>       - cn_coord0 : coordinate file
+!>       - in_perio0 : NEMO periodicity index (see Model Boundary Condition in
+!> [NEMO documentation](http://www.nemo-ocean.eu/About-NEMO/Reference-manuals))
+!>
+!>    * _fine grid namelist (namfin)_:<br/>
+!>       - cn_coord1 : coordinate file
+!>       - cn_bathy1 : bathymetry file
+!>       - in_perio1 : NEMO periodicity index
+!>       - in_extrap : number of land point to be extrapolated 
+!>       before writing file
+!>
+!>    * _vertical grid namelist (namzgr)_:<br/>
+!>       - dn_pp_to_be_computed  :
+!>       - dn_ppsur              :
+!>       - dn_ppa0               :
+!>       - dn_ppa1               :
+!>       - dn_ppa2               : 
+!>       - dn_ppkth              :
+!>       - dn_ppkth2             :
+!>       - dn_ppacr              :
+!>       - dn_ppacr2             :
+!>       - dn_ppdzmin            :
+!>       - dn_pphmax             :
+!>       - in_nlevel             : number of vertical level
+!>
+!>    * _partial step namelist (namzps)_:<br/>
+!>       - dn_e3zps_min          :
+!>       - dn_e3zps_rat          : 
+!>
+!>    * _variable namelist (namvar)_:<br/>
+!>       - cn_varinfo : list of variable and extra information about request(s) 
+!>       to be used.<br/>
+!>          each elements of *cn_varinfo* is a string character.<br/>
+!>          it is composed of the variable name follow by ':', 
+!>          then request(s) to be used on this variable.<br/> 
+!>          request could be:
+!>             - interpolation method
+!>             - extrapolation method
+!>             - filter method
+!>             - > minimum value
+!>             - < maximum value
+!>
+!>             requests must be separated by ';'.<br/>
+!>             order of requests does not matter.<br/>
+!>
+!>          informations about available method could be find in @ref interp,
+!>          @ref extrap and @ref filter.<br/>
+!>          Example: 'votemper: linear; hann; dist_weight','vosaline: cubic'
+!>          @note 
+!>             If you do not specify a method which is required, 
+!>             default one is apply.
+!>       - cn_varfile : list of variable, and corresponding file<br/> 
+!>          *cn_varfile* is the path and filename of the file where find
+!>          variable.<br/>
+!>          @note 
+!>             *cn_varfile* could be a matrix of value, if you want to filled
+!>             manually variable value.<br/>
+!>             the variable array of value is split into equal subdomain.<br/>
+!>             Each subdomain is filled with the corresponding value 
+!>             of the matrix.<br/>          
+!>             separators used to defined matrix are:
+!>                - ',' for line
+!>                - '/' for row
+!>                - '\' for level<br/>
+!>                Example:<br/>
+!>                   3,2,3/1,4,5  =>  @f$ \left( \begin{array}{ccc}
+!>                                         3 & 2 & 3 \\
+!>                                         1 & 4 & 5 \end{array} \right) @f$
+!>
+!>          Examples: 
+!>             - 'votemper:gridT.nc', 'vozocrtx:gridU.nc'
+!>             - 'votemper:10\25', 'vozocrtx:gridU.nc'
+!>
+!>             to get all variable from one file:
+!>             - 'all:restart.dimg'
+!>
+!>    * _nesting namelist (namnst)_:<br/>
+!>       - in_rhoi  : refinement factor in i-direction
+!>       - in_rhoj  : refinement factor in j-direction
+!>       @note 
+!>          coarse grid indices will be deduced from fine grid
+!>          coordinate file.
+!>
+!>    * _output namelist (namout)_:<br/>
+!>       - cn_fileout : output file
+!>       - in_nproc  : total number of processor to be used
+!>       - in_niproc : i-direction number of processor
+!>       - in_njproc : j-direction numebr of processor
+!>       - cn_type   : output format ('dimg', 'cdf')
+!>
+!> @author J.Paul
 ! REVISION HISTORY:
-!> @date Nov, 2013 - Initial Version
-!
+!> @date November, 2013 - Initial Version
+!> @date September, 2014
+!> - add header for user
+!> - offset computed considering grid point
+!> - add attributes in output variable
+!>
 !> @note Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
-!>
-!> @todo
-!> - add attributes indices and refinement in output file
-!> - check fileout exist at the beginning
 !----------------------------------------------------------------------
-!> @code
 PROGRAM create_restart
 
-!   USE netcdf                         ! nf90 library
    USE global                          ! global variable
    USE kind                            ! F90 kind parameter
@@ -41,5 +164,4 @@
    USE multi                           ! multi file manager
    USE iom                             ! I/O manager
-   USE dom                             ! domain manager
    USE grid                            ! grid manager
    USE vgrid                           ! vertical grid manager
@@ -48,5 +170,7 @@
    USE filter                          ! filter manager
    USE mpp                             ! MPP manager
+   USE dom                             ! domain manager
    USE iom_mpp                         ! MPP I/O manager
+   USE iom_dom                         ! DOM I/O manager
 
    IMPLICIT NONE
@@ -58,24 +182,26 @@
    CHARACTER(LEN=lc)                                  :: cl_name
    CHARACTER(LEN=lc)                                  :: cl_data
+   CHARACTER(LEN=lc)                                  :: cl_fileout 
 
    INTEGER(i4)                                        :: il_narg
    INTEGER(i4)                                        :: il_status
    INTEGER(i4)                                        :: il_fileid
+   INTEGER(i4)                                        :: il_nvar
    INTEGER(i4)                                        :: il_attid
+   INTEGER(i4)                                        :: il_imin1
+   INTEGER(i4)                                        :: il_imax1
+   INTEGER(i4)                                        :: il_jmin1
+   INTEGER(i4)                                        :: il_jmax1
    INTEGER(i4)                                        :: il_imin0
    INTEGER(i4)                                        :: il_imax0
    INTEGER(i4)                                        :: il_jmin0
    INTEGER(i4)                                        :: il_jmax0
+   INTEGER(i4)                                        :: il_index
    INTEGER(i4)      , DIMENSION(ip_maxdim)            :: il_rho
-   INTEGER(i4)      , DIMENSION(2)                    :: il_xghost
+   INTEGER(i4)      , DIMENSION(2,2)                  :: il_xghost
    INTEGER(i4)      , DIMENSION(2,2)                  :: il_offset
-   INTEGER(i4)      , DIMENSION(2,2,2)                :: il_ind
+   INTEGER(i4)      , DIMENSION(2,2)                  :: il_ind
 
    LOGICAL                                            :: ll_exist
-
-   TYPE(TFILE)                                        :: tl_coord0
-   TYPE(TFILE)                                        :: tl_coord1
-   TYPE(TFILE)                                        :: tl_bathy1
-   TYPE(TFILE)                                        :: tl_file
 
    TYPE(TDOM)                                         :: tl_dom1
@@ -88,5 +214,4 @@
    TYPE(TVAR)                                         :: tl_lon
    TYPE(TVAR)                                         :: tl_lat
-   TYPE(TVAR)                                         :: tl_tmp
    TYPE(TVAR)       , DIMENSION(:)      , ALLOCATABLE :: tl_var
    TYPE(TVAR)       , DIMENSION(:)      , ALLOCATABLE :: tl_level
@@ -94,6 +219,10 @@
    TYPE(TDIM)       , DIMENSION(ip_maxdim)            :: tl_dim
 
+   TYPE(TMPP)                                         :: tl_coord0
+   TYPE(TMPP)                                         :: tl_coord1
+   TYPE(TMPP)                                         :: tl_bathy1
    TYPE(TMPP)                                         :: tl_mpp
    TYPE(TMPP)                                         :: tl_mppout
+
    TYPE(TMULTI)                                       :: tl_multi
 
@@ -104,29 +233,50 @@
 
    ! namelist variable
+   ! namlog
    CHARACTER(LEN=lc) :: cn_logfile = 'create_restart.log' 
    CHARACTER(LEN=lc) :: cn_verbosity = 'warning' 
-
+   INTEGER(i4)       :: in_maxerror = 5
+
+   ! namcfg
    CHARACTER(LEN=lc) :: cn_varcfg = 'variable.cfg' 
 
+   ! namcrs
    CHARACTER(LEN=lc) :: cn_coord0 = '' 
    INTEGER(i4)       :: in_perio0 = -1
 
+   ! namfin
    CHARACTER(LEN=lc) :: cn_coord1 = ''
    CHARACTER(LEN=lc) :: cn_bathy1 = ''
    INTEGER(i4)       :: in_perio1 = -1
    INTEGER(i4)       :: in_extrap = 0
-   LOGICAL           :: ln_fillclosed = .TRUE.
-
-   CHARACTER(LEN=lc), DIMENSION(ig_maxvar) :: cn_varinfo = ''
-   CHARACTER(LEN=lc), DIMENSION(ig_maxvar) :: cn_varfile = ''
-
-   INTEGER(i4)       :: in_imin0 = 0
-   INTEGER(i4)       :: in_imax0 = 0
-   INTEGER(i4)       :: in_jmin0 = 0
-   INTEGER(i4)       :: in_jmax0 = 0
+
+   !namzgr
+   REAL(dp)          :: dn_pp_to_be_computed = 0._dp
+   REAL(dp)          :: dn_ppsur     = -3958.951371276829_dp
+   REAL(dp)          :: dn_ppa0      =   103.9530096000000_dp
+   REAL(dp)          :: dn_ppa1      =     2.4159512690000_dp
+   REAL(dp)          :: dn_ppa2      =   100.7609285000000_dp
+   REAL(dp)          :: dn_ppkth     =    15.3510137000000_dp
+   REAL(dp)          :: dn_ppkth2    =    48.0298937200000_dp
+   REAL(dp)          :: dn_ppacr     =     7.0000000000000_dp
+   REAL(dp)          :: dn_ppacr2    =    13.000000000000_dp
+   REAL(dp)          :: dn_ppdzmin   = 6._dp
+   REAL(dp)          :: dn_pphmax    = 5750._dp
+   INTEGER(i4)       :: in_nlevel    = 75
+
+   !namzps
+   REAL(dp)          :: dn_e3zps_min = 25._dp
+   REAL(dp)          :: dn_e3zps_rat = 0.2_dp
+
+   ! namvar
+   CHARACTER(LEN=lc), DIMENSION(ip_maxvar) :: cn_varinfo = ''
+   CHARACTER(LEN=lc), DIMENSION(ip_maxvar) :: cn_varfile = ''
+
+   ! namnst
    INTEGER(i4)       :: in_rhoi = 0
    INTEGER(i4)       :: in_rhoj = 0
 
-   CHARACTER(LEN=lc) :: cn_fileout = 'restart' 
+   ! namout
+   CHARACTER(LEN=lc) :: cn_fileout = 'restart.nc' 
    INTEGER(i4)       :: in_nproc   = 0
    INTEGER(i4)       :: in_niproc  = 0
@@ -138,29 +288,43 @@
    NAMELIST /namlog/ &  !< logger namelist
    &  cn_logfile,    &  !< log file
-   &  cn_verbosity      !< log verbosity
+   &  cn_verbosity,  &  !< log verbosity
+   &  in_maxerror       !< logger maximum error
 
    NAMELIST /namcfg/ &  !< configuration namelist
    &  cn_varcfg         !< variable configuration file
 
-   NAMELIST /namcrs/ &   !< coarse grid namelist
-   &  cn_coord0,  &      !< coordinate file
-   &  in_perio0          !< periodicity index
+   NAMELIST /namcrs/ &  !< coarse grid namelist
+   &  cn_coord0,  &     !< coordinate file
+   &  in_perio0         !< periodicity index
    
-   NAMELIST /namfin/ &   !< fine grid namelist
-   &  cn_coord1,   &     !< coordinate file
-   &  cn_bathy1,   &     !< bathymetry file
-   &  in_perio1,   &     !< periodicity index
-   &  in_extrap,   &     !<
-   &  ln_fillclosed      !< fill closed sea
+   NAMELIST /namfin/ &  !< fine grid namelist
+   &  cn_coord1,   &    !< coordinate file
+   &  cn_bathy1,   &    !< bathymetry file
+   &  in_perio1,   &    !< periodicity index
+   &  in_extrap
  
+   NAMELIST /namzgr/ &
+   &  dn_pp_to_be_computed, &
+   &  dn_ppsur,     &
+   &  dn_ppa0,      &
+   &  dn_ppa1,      &
+   &  dn_ppa2,      &
+   &  dn_ppkth,     &
+   &  dn_ppkth2,    &
+   &  dn_ppacr,     &
+   &  dn_ppacr2,    &
+   &  dn_ppdzmin,   &
+   &  dn_pphmax,    &
+   &  in_nlevel         !< number of vertical level
+
+   NAMELIST /namzps/ &
+   &  dn_e3zps_min, &
+   &  dn_e3zps_rat
+
    NAMELIST /namvar/ &  !< variable namelist
-   &  cn_varinfo, &     !< list of variable and interpolation method to be used. (ex: 'votemper:linear','vosaline:cubic' )
+   &  cn_varinfo, &     !< list of variable and interpolation method to be used.
    &  cn_varfile        !< list of variable file
    
    NAMELIST /namnst/ &  !< nesting namelist
-   &  in_imin0,    &     !< i-direction lower left  point indice 
-   &  in_imax0,    &     !< i-direction upper right point indice
-   &  in_jmin0,    &     !< j-direction lower left  point indice
-   &  in_jmax0,    &     !< j-direction upper right point indice
    &  in_rhoi,    &     !< refinement factor in i-direction
    &  in_rhoj           !< refinement factor in j-direction
@@ -174,6 +338,6 @@
    !-------------------------------------------------------------------
 
-   !1- namelist
-   !1-1 get namelist
+   ! namelist
+   ! get namelist
    il_narg=COMMAND_ARGUMENT_COUNT() !f03 intrinsec
    IF( il_narg/=1 )THEN
@@ -184,5 +348,5 @@
    ENDIF
    
-   !1-2 read namelist
+   ! read namelist
    INQUIRE(FILE=TRIM(cl_namelist), EXIST=ll_exist)
    IF( ll_exist )THEN
@@ -203,18 +367,19 @@
 
       READ( il_fileid, NML = namlog )
-      !1-2-1 define log file
-      CALL logger_open(TRIM(cn_logfile),TRIM(cn_verbosity))
+      ! define log file
+      CALL logger_open(TRIM(cn_logfile),TRIM(cn_verbosity),in_maxerror)
       CALL logger_header()
 
       READ( il_fileid, NML = namcfg )
-      !1-2-2 get variable extra information
+      ! get variable extra information
       CALL var_def_extra(TRIM(cn_varcfg))
 
       READ( il_fileid, NML = namcrs )
       READ( il_fileid, NML = namfin )
+      READ( il_fileid, NML = namzgr )
       READ( il_fileid, NML = namvar )
-      !1-2-3 add user change in extra information
+      ! add user change in extra information
       CALL var_chg_extra(cn_varinfo)
-      !1-2-4 match variable with file
+      ! match variable with file
       tl_multi=multi_init(cn_varfile)
       
@@ -231,11 +396,19 @@
 
       PRINT *,"ERROR in create_restart: can't find "//TRIM(cl_namelist)
-
-   ENDIF
-
-   !2- open files
+      STOP
+
+   ENDIF
+
+   ! 
+   CALL multi_print(tl_multi)
+   IF( tl_multi%i_nvar <= 0 )THEN
+      CALL logger_fatal("CREATE RESTART: no variable to be used."//&
+      &  " check namelist.")
+   ENDIF
+
+   ! open files
    IF( cn_coord0 /= '' )THEN
-      tl_coord0=file_init(TRIM(cn_coord0),id_perio=in_perio0)
-      CALL iom_open(tl_coord0)
+      tl_coord0=mpp_init( file_init(TRIM(cn_coord0)), id_perio=in_perio0)
+      CALL grid_get_info(tl_coord0)
    ELSE
       CALL logger_fatal("CREATE RESTART: no coarse grid coordinate found. "//&
@@ -244,6 +417,6 @@
 
    IF( TRIM(cn_coord1) /= '' )THEN
-      tl_coord1=file_init(TRIM(cn_coord1),id_perio=in_perio1)
-      CALL iom_open(tl_coord1)
+      tl_coord1=mpp_init( file_init(TRIM(cn_coord1)), id_perio=in_perio1)
+      CALL grid_get_info(tl_coord1)
    ELSE
       CALL logger_fatal("CREATE RESTART: no fine grid coordinate found. "//&
@@ -252,6 +425,6 @@
 
    IF( TRIM(cn_bathy1) /= '' )THEN
-      tl_bathy1=file_init(TRIM(cn_bathy1),id_perio=in_perio1)
-      CALL iom_open(tl_bathy1)
+      tl_bathy1=mpp_init( file_init(TRIM(cn_bathy1)), id_perio=in_perio1)
+      CALL grid_get_info(tl_bathy1)
    ELSE
       CALL logger_fatal("CREATE RESTART: no fine grid bathymetry found. "//&
@@ -259,6 +432,14 @@
    ENDIF
 
-   !3- check
-   !3-2-1 check refinement factor
+   ! check
+   ! check output file do not already exist
+   cl_fileout=file_rename(cn_fileout,1)
+   INQUIRE(FILE=TRIM(cl_fileout), EXIST=ll_exist)
+   IF( ll_exist )THEN
+      CALL logger_fatal("CREATE RESTART: output file "//TRIM(cl_fileout)//&
+      &  " already exist.")
+   ENDIF
+
+   ! check refinement factor
    il_rho(:)=1
    IF( in_rhoi < 1 .OR. in_rhoj < 1 )THEN
@@ -270,163 +451,164 @@
    ENDIF
 
-   IF( cn_coord0 /= '' )THEN !.OR. cn_bathy0 /= '' )THEN
-
-      !3-1 check namelist
-      IF( in_imin0 < 1 .OR. in_imax0 < 1 .OR. in_jmin0 < 1 .OR. in_jmax0 < 1)THEN
-         ! compute coarse grid indices around fine grid
-         IF( cn_coord0 /= '' )THEN
-            il_ind(:,:,:)=grid_get_coarse_index(tl_coord0, tl_coord1 )
-         ENDIF
-
-         il_imin0=il_ind(1,1,1) ; il_imax0=il_ind(1,2,1)
-         il_jmin0=il_ind(2,1,1) ; il_jmax0=il_ind(2,2,1)
-
-         il_offset(:,:)=il_ind(:,:,2)
-      ELSE
-         il_imin0=in_imin0 ; il_imax0=in_imax0
-         il_jmin0=in_jmin0 ; il_jmax0=in_jmax0
-
-         il_offset(1,:)=FLOOR(REAL(il_rho(jp_I)-1,dp)*0.5)
-         il_offset(2,:)=FLOOR(REAL(il_rho(jp_J)-1,dp)*0.5)         
-      ENDIF
-
-      !3-2 check domain validity
-      IF( cn_coord0 /= '' )THEN
-         CALL grid_check_dom(tl_coord0, il_imin0, il_imax0, il_jmin0, il_jmax0)
-      ENDIF
-
-      !3-3 check coordinate file
-      IF( cn_coord0 /= '' )THEN
-         CALL grid_check_coincidence( tl_coord0, tl_coord1, &
-         &                            il_imin0, il_imax0, &
-         &                            il_jmin0, il_jmax0, &
-         &                            il_rho(:) )
-      ENDIF
-
-   ENDIF
+   ! check domain indices
+   ! compute coarse grid indices around fine grid
+   il_ind(:,:)=grid_get_coarse_index(tl_coord0, tl_coord1, &
+   &                                 id_rho=il_rho(:))
+
+   il_imin0=il_ind(1,1) ; il_imax0=il_ind(1,2)
+   il_jmin0=il_ind(2,1) ; il_jmax0=il_ind(2,2)
+
+   ! check domain validity
+   CALL grid_check_dom(tl_coord0, il_imin0, il_imax0, il_jmin0, il_jmax0)
+
+   !3-2-4 check coincidence between coarse and fine grid
+   CALL grid_check_coincidence( tl_coord0, tl_coord1, &
+   &                            il_imin0, il_imax0, &
+   &                            il_jmin0, il_jmax0, &
+   &                            il_rho(:) )
 
    ! compute level
-   ALLOCATE(tl_level(ig_npoint))
+   ALLOCATE(tl_level(ip_npoint))
    tl_level(:)=vgrid_get_level(tl_bathy1, cl_namelist )
 
    ! remove ghost cell
-   il_xghost(:)=grid_get_ghost(tl_bathy1)
-
-   DO ji=1,ig_npoint
-      CALL grid_del_ghost(tl_level(ji), il_xghost(1), il_xghost(2))
+   il_xghost(:,:)=grid_get_ghost(tl_bathy1)
+   DO ji=1,ip_npoint
+      CALL grid_del_ghost(tl_level(ji), il_xghost(:,:))
    ENDDO
 
-   ! close
-   CALL iom_close(tl_bathy1)
-
-   !4- work on variables
-   IF( .NOT. ASSOCIATED(tl_multi%t_file) )THEN
+   ! clean
+   CALL mpp_clean(tl_bathy1)
+
+   ! work on variables
+   IF( .NOT. ASSOCIATED(tl_multi%t_mpp) )THEN
       CALL logger_error("CREATE RESTART: no file to work on. "//&
       &                 "check cn_varfile in namelist.")
    ELSE
       ALLOCATE( tl_var( tl_multi%i_nvar ) )
+
       jvar=0
       ! for each file
-      DO ji=1,tl_multi%i_nfile
-         WRITE(cl_data,'(a,i2.2)') 'data_',jvar+1
-
-         IF( .NOT. ASSOCIATED(tl_multi%t_file(ji)%t_var) )THEN
+      DO ji=1,tl_multi%i_nmpp
+         WRITE(cl_data,'(a,i2.2)') 'data-',jvar+1
+
+         IF( .NOT. ASSOCIATED(tl_multi%t_mpp(ji)%t_proc(1)%t_var) )THEN
 
             CALL logger_error("CREATE RESTART: no variable to work on for "//&
-            &                 "file "//TRIM(tl_multi%t_file(ji)%c_name)//&
+            &                 "mpp "//TRIM(tl_multi%t_mpp(ji)%c_name)//&
             &                 ". check cn_varfile in namelist.")
 
-         ELSEIF( TRIM(tl_multi%t_file(ji)%c_name) == TRIM(cl_data) )THEN
-         !4-1 use input matrix to fill variable
-
+         ELSEIF( TRIM(tl_multi%t_mpp(ji)%c_name) == TRIM(cl_data) )THEN
+         !- use input matrix to fill variable
+
+            WRITE(*,'(a)') "work on data"
             ! for each variable initialise from matrix
-            DO jj=1,tl_multi%t_file(ji)%i_nvar
+            DO jj=1,tl_multi%t_mpp(ji)%t_proc(1)%i_nvar
+
                jvar=jvar+1
-               tl_tmp=tl_multi%t_file(ji)%t_var(jj)
-               !4-1-1 fill value with matrix data
-               ! pb voir comment gerer nb de dimension
-               tl_var(jvar)=create_restart_matrix(tl_tmp, tl_coord1)
-
-               !4-1-2 use mask
-               CALL create_restart_mask(tl_var(jvar), tl_level(:))
+               
+               WRITE(*,'(2x,a,a)') "work on variable "//&
+               &  TRIM(tl_multi%t_mpp(ji)%t_proc(1)%t_var(jj)%c_name)
+
+               ! fill value with matrix data
+               tl_var(jvar) = create_restart_matrix( &
+               &  tl_multi%t_mpp(ji)%t_proc(1)%t_var(jj), tl_coord1, &
+               &  in_nlevel, tl_level(:) )
+
             ENDDO
-
+         !- end of use input matrix to fill variable
          ELSE
-         !4-2 use file to fill variable
-
-            ! open file
-            tl_file=file_init(TRIM(tl_multi%t_file(ji)%c_name))
-            CALL iom_open(tl_file)
+         !- use mpp file to fill variable
+
+            WRITE(*,'(a)') "work on file "//TRIM(tl_multi%t_mpp(ji)%c_name)
+            !
+            tl_mpp=mpp_init( file_init(TRIM(tl_multi%t_mpp(ji)%t_proc(1)%c_name)) )
+            CALL grid_get_info(tl_mpp)
+
+            ! check vertical dimension
+            IF( tl_mpp%t_dim(jp_K)%l_use .AND. &
+            &   tl_mpp%t_dim(jp_K)%i_len /= in_nlevel  )THEN
+               CALL logger_error("CREATE RESTART: dimension in file "//&
+               &  TRIM(tl_mpp%c_name)//" not agree with namelist in_nlevel ")
+            ENDIF
+
+            ! open mpp file
+            CALL iom_mpp_open(tl_mpp)
 
             ! get or check depth value
-            IF( tl_file%i_depthid /= 0 )THEN
-               IF( ASSOCIATED(tl_depth%d_value) )THEN
-                  IF( ANY( tl_depth%d_value(:,:,:,:) /= &
-                  &        tl_tmp%d_value(:,:,:,:) ) )THEN
-                     CALL logger_fatal("CREATE RESTART: depth value from "//&
-                     &  TRIM(tl_multi%t_file(ji)%c_name)//" not conform "//&
-                     &  " to those from former file(s).")
-                  ENDIF
-               ELSE
-                  tl_depth=iom_read_var(tl_file,tl_file%i_depthid)
+            CALL create_restart_check_depth( tl_mpp, tl_depth )
+
+            ! get or check time value
+            CALL create_restart_check_time( tl_mpp, tl_time )
+
+            ! close mpp file
+            CALL iom_mpp_close(tl_mpp)
+
+            IF( ANY( tl_mpp%t_dim(1:2)%i_len /= &
+            &        tl_coord0%t_dim(1:2)%i_len) )THEN
+            !!! extract value from fine grid 
+
+               IF( ANY( tl_mpp%t_dim(1:2)%i_len <= &
+               &        tl_coord1%t_dim(1:2)%i_len) )THEN
+                  CALL logger_fatal("CREATE RESTART: dimension in file "//&
+                  &  TRIM(tl_mpp%c_name)//" smaller than those in fine"//&
+                  &  " grid coordinates.")
                ENDIF
-            ENDIF
-
-            ! get or check time value
-            IF( tl_file%i_timeid /= 0 )THEN
-               IF( ASSOCIATED(tl_time%d_value) )THEN
-                  IF( ANY( tl_time%d_value(:,:,:,:) /= &
-                  &        tl_tmp%d_value(:,:,:,:) ) )THEN
-                     CALL logger_fatal("CREATE RESTART: time value from "//&
-                     &  TRIM(tl_multi%t_file(ji)%c_name)//" not conform "//&
-                     &  " to those from former file(s).")
-                  ENDIF
-               ELSE
-                  tl_time=iom_read_var(tl_file,tl_file%i_timeid)
-               ENDIF
-            ENDIF
-
-            IF( ANY( tl_file%t_dim(1:2)%i_len /= &
-            &      tl_coord0%t_dim(1:2)%i_len) )THEN
-            !4-2-1 extract value from fine grid 
-
-               !4-2-1-1 compute domain on fine grid
-               tl_dom1=create__restart_get_dom_coord(tl_file, tl_coord1)
+
+               ! compute domain on fine grid
+               il_ind(:,:)=grid_get_coarse_index(tl_mpp, tl_coord1 )
+
+               il_imin1=il_ind(1,1) ; il_imax1=il_ind(1,2)
+               il_jmin1=il_ind(2,1) ; il_jmax1=il_ind(2,2)
+
+               !- check grid coincidence
+               CALL grid_check_coincidence( tl_mpp, tl_coord1, &
+               &                            il_imin1, il_imax1, &
+               &                            il_jmin1, il_jmax1, &
+               &                            il_rho(:) )
+
+               ! compute domain
+               tl_dom1=dom_init(tl_mpp,         &
+               &                il_imin1, il_imax1, &
+               &                il_jmin1, il_jmax1)
                
-               ! open mpp file on domain
-               !4-2-1-2 init mpp structure
-               tl_mpp=mpp_init(tl_file)
-
-               !4-2-1-3 get processor to be used
-               CALL mpp_get_use( tl_mpp, tl_dom1 )
-               !4-2-1-4 open mpp files
-               CALL iom_mpp_open(tl_mpp)
+               ! open mpp files
+               CALL iom_dom_open(tl_mpp, tl_dom1)
 
                ! for each variable of this file
-               DO jj=1,tl_multi%t_file(ji)%i_nvar
+               DO jj=1,tl_multi%t_mpp(ji)%t_proc(1)%i_nvar
+
+                  WRITE(*,'(2x,a,a)') "work on variable "//&
+                  &  TRIM(tl_multi%t_mpp(ji)%t_proc(1)%t_var(jj)%c_name)
+
                   jvar=jvar+1
-                  cl_name=tl_multi%t_file(ji)%t_var(jj)%c_name
-                  !4-2-1-5 read variable over domain
-                  tl_var(jvar)=iom_mpp_read_var( tl_mpp, TRIM(cl_name), &
-                  &                              td_dom=tl_dom1 )
-
-                  !4-2-1-7 add attribute to variable
+                  cl_name=tl_multi%t_mpp(ji)%t_proc(1)%t_var(jj)%c_name
+                  ! read variable over domain
+                  tl_var(jvar)=iom_dom_read_var(tl_mpp, TRIM(cl_name), tl_dom1)
+
+                  ! add attribute to variable
                   tl_att=att_init('src_file',TRIM(fct_basename(tl_mpp%c_name)))
                   CALL var_move_att(tl_var(jvar), tl_att)
 
+                  tl_att=att_init('src_i_indices',(/il_imin0, il_imax0/))
+                  CALL var_move_att(tl_var(jvar), tl_att)
+
+                  tl_att=att_init('src_j_indices',(/il_jmin0, il_jmax0/))
+                  CALL var_move_att(tl_var(jvar), tl_att)
+
                   ! clean structure
                   CALL att_clean(tl_att)
 
-                  !4-2-1-8 use mask
+                  ! use mask
                   CALL create_restart_mask(tl_var(jvar), tl_level(:))
 
-                  !4-2-1-9 add ghost cell
-                  CALL grid_add_ghost( tl_var(jvar), &
-                  &                    tl_dom1%i_ighost,tl_dom1%i_jghost )
+                  ! add ghost cell
+                  CALL grid_add_ghost( tl_var(jvar), tl_dom1%i_ghost(:,:) )
 
                ENDDO
 
-               !4-2-1-2 close mpp file
-               CALL iom_mpp_close(tl_mpp)
+               ! close mpp file
+               CALL iom_dom_close(tl_mpp)
+
                ! clean structure
                CALL mpp_clean(tl_mpp)
